#include "rwmake.ch"
#include "topconn.ch"
#include "TbiConn.ch"
#include "TbiCode.ch"

/*
+----------------------------------------------------------------------------+
!                             FICHA TECNICA DO PROGRAMA                      !
+----------------------------------------------------------------------------+
!   DADOS DO PROGRAMA                                                        !
+------------------+---------------------------------------------------------+
!Tipo              ! Ponto de entrada                                        !
+------------------+---------------------------------------------------------+
!Modulo            ! Diversos                                                !
+------------------+---------------------------------------------------------+
!Nome              ! MT130WF                                                 !
+------------------+---------------------------------------------------------+
!Descricao         ! Ponto de entrada para envio de WF da cotao de compras !
+------------------+---------------------------------------------------------+
!Autor             ! Rodrigo Araujo                                          !
+------------------+---------------------------------------------------------+
!Data de Criacao   ! 22/07/2011                                              !
+------------------+---------------------------------------------------------+
!   ATUALIZACOES                                                             !
+-------------------------------------------+-----------+-----------+--------+
!   Descricao detalhada da atualizacao      !Nome do    ! Analista  !Data da !
!                                           !Solicitante! Respons.  !Atualiz.!
+-------------------------------------------+-----------+-----------+--------+
!                                           !           !           !        !
+-------------------------------------------+-----------+-----------+--------+
*/

user function MT130WF(oProcess)

	local cEmail   := Space(50)
	local cMailFor := ''
	local cQry     := ''
	local cSubject := ''
	
	private cC8_NUM
	private cC8_FORNECE
	private cC8_LOJA  
		
    cQry := " SELECT DISTINCT C8_NUM, C8_FORNECE, C8_LOJA, C8_CONTATO"
    cQry += " FROM "+ RetSqlName('SC8') +" SC8"
	cQry += " WHERE SC8.D_E_L_E_T_<> '*'"
	cQry += "   AND C8_FILIAL      = '"+ xFilial('SC8') +"'"
    cQry += "   AND C8_NUM         = '"+ ParamIXB[1] +"'"
	    
    LimpaArea('TMP')
    
    TCQuery cQry New Alias "TMP"
	    
	if TMP->(!eof())
		while TMP->(!eof())

			cC8_NUM     := TMP->C8_NUM
			cC8_FORNECE := TMP->C8_FORNECE
			cC8_LOJA    := TMP->C8_LOJA

			// Tabela de Fornecedores
			dbSelectArea('SA2')
			dbSetOrder(1)
			dbSeek(xFilial('SA2') + cC8_FORNECE + cC8_LOJA)

			if !(MsgYesNo("Envia cotao para o Fornecedor " + SA2->A2_COD + "/" + cC8_LOJA + " - " + alltrim(SA2->A2_NOME) + " ?"))
				TMP->(dbSkip())
				loop
			endif
            
			cMailFor := alltrim(SA2->A2_EMAIL)

			//Caso nao encontre um e-mail
			if empty(cMailFor)                
				cFornecedor := rTrim(allTrim(SA2->A2_COD) + " - " + lTrim(SA2->A2_NOME))
				if MsgYesNo("O Fornecedor '" + cFornecedor + "' no tem um email cadastrado, deseja cadastrar agora?")

					@ 100, 100 To 200, 400 dialog oDlg title oemToAnsi("Endereo de e-mail")
					@ 012, 012 say oemToAnsi("E-mail") size 100, 10
					@ 012, 040 get cEmail size 80,10

					@ 030, 050 BMPBUTTON TYPE 1 ACTION close(oDlg)

					Activate Dialog oDlg Centered

					//Grava o email no SA2
					recLock("SA2", .f.)
						A2_EMAIL := cEmail
					msUnlock()

					cMailFor := cEmail
				endif
			endif
            
			cMailFor += ";compras@marel.com"//alltrim(SA2->A2_EMAIL)

			if !empty(Alltrim(cMailFor))
				dbSelectArea('SA2')
				dbSetOrder(1)
				dbSeek( xFilial('SA2') + cC8_FORNECE + cC8_LOJA )
				
				cSubject := "Processo de gerao de Cotao de Preos: " + cC8_NUM
				                                
				if U_MailTo(cMailFor, cSubject, MontaMSG())
					ApMsgInfo("E-mail enviado com sucesso para " + ALLTRIM(SA2->A2_NOME) + "!","[MT130WF] - OK")				
				EndIf
			else
				cFornecedor := rTrim(allTrim(SA2->A2_COD) + " - " + lTrim(SA2->A2_NOME))                                   
				cMsg := "Solicitao do oramento '" + cC8_NUM + "' no enviado devido a falta de cadastro de e-mail do fornecedor '" + cFornecedor + '"."
				aviso("Solicitao de oramento.", cMsg, {"ok"}, 3)
			endif

			TMP->(dbSkip())
		enddo
	endif

return
**************************************************************************
static function MontaMSG()

	local cBody    := ''
	local cRand    := alltrim(str(randomize(100000, 999999)))
	local cKey     := embaralha(alltrim(SA2->A2_COD) + "|" + alltrim(SA2->A2_LOJA) + "|" + cC8_NUM + "|" + cRand, 0 )
	
	cBody += '<table style="width:100%; height:100%;">
	cBody += '	<tr>
	cBody += '		<td height="30" align="center" style="font-family: Verdana; font-size: 10pt; font-weight:bold">
	cBody += '			Mensagem automatica, no responda este email!
	cBody += '		</td>
	cBody += '	</tr>
	cBody += '	<tr>
	cBody += '		<td align="center" style="font-family: Verdana; font-size: 10pt; color:gray">
	cBody += '			<div style="width:500px; padding-top:20px" align="left">
	cBody += '				Voc esta recebendo uma nova solicitao de cotao. Por favor, para responder a esta solicitao, acesse o portal
	cBody += '				de cotao online atravs do link abaixo.
	cBody += '			</div>
	cBody += '							
	cBody += '			<div style="width:500px; padding-top:20px" align="center" style="font-family: Tahoma; color:red; font-size:18px; font-weight:bold;">
	cBody += '				Cotao online<br>
	cBody += '				<a href="http://www.marel.com/agenda/U_ATUCOTA.APW?keyvalue=' + cKey + '" style="font-family: Verdana; font-size: 8pt; color:red; text-decoration:none">
	cBody += '					Clique aqui para responder a cotao!
	cBody += '				</a>
	cBody += '			</div>
	cBody += '					
	cBody += '			<div style="width:100%; padding-top:20px" align="center">
	cBody += '				Se preferir, voc pode acessar o portal utilizando o endereo descrito abaixo.
	cBody += '				<br><br>
	cBody += '				http://www.marel.com/agenda/U_ATUCOTA.APW?keyvalue=' + cKey
	cBody += '			</div>
	cBody += '		</td>
	cBody += '	</tr>
	cBody += '</table>

return cBody
**************************************************************************
static function LimpaArea(area)

   	if select(area) > 0
		dbSelectArea(area)
		dbCloseArea()
	endIf

return